from sklearn.datasets import fetch_20newsgroups
from sklearn.feature_extraction.text import TfidfVectorizer
import sys
sys.path.append('..')
sys.path.append('.')
import numpy as np
import argparse

parser = argparse.ArgumentParser(description='20Text')
parser.add_argument('--device', type=int)
parser.add_argument('--epoch', type=int,default=500,help="Number of epochs to train.")
parser.add_argument('--modalities', type=int, default=3, help='Number of modalities')
parser.add_argument('--labeled', type=int, default=500, help='Number of labeled data')
parser.add_argument('--thresh', type=float, default=0.9, help='Threshold')
parser.add_argument('--mig', type=int, default=0, help='MIG or not')
parser.add_argument('--vat', type=int, default=0, help='VAT or not')
parser.add_argument('--lambda2', type=float, default=10, help='VAT or not')
parser.add_argument('--lambda1', type=float, default=10.0, help='VAT perturbation( best hyper is default)')
args = parser.parse_args()

'''
categories = ['alt.atheism', 'talk.religion.misc','comp.graphics']
newsgroups_train = fetch_20newsgroups(subset='train',remove=('headers', 'footers', 'quotes'),categories=categories)
newsgroups_test = fetch_20newsgroups(subset='test',remove=('headers', 'footers', 'quotes'),
categories=categories)
vectorizer = TfidfVectorizer()
vectors_train = np.array(vectorizer.fit_transform(newsgroups_train.data).todense(),dtype=np.float32)
vectors_train_target = np.array(newsgroups_train.target)
vectors_test = np.array(vectorizer.transform(newsgroups_test.data).todense(),dtype=np.float32)
vectors_test_target = np.array(newsgroups_test.target,)
'''
import numpy as np
from scipy import io
import os
import torch

best_test_acc = np.zeros(args.modalities)
best_val_acc = np.zeros(args.modalities)

from dataset.M2Reader import view_train,view_test,split,label_train,label_test,label_val,view_val

for i in range(1,4):
    view_train[i] = view_train[i].numpy()
    view_test[i] = view_test[i].numpy()
    view_val[i] = view_val[i].numpy()

box = [1e5,1e4,1e3,1e2,1,1e-1,1e-2,1e-3,1e-4,1e-5]
lambda1_box = [1,1e-1,1e-2,1e-3,1e-4,1e-5]
v = args.modalities
N = len(label_train)
#lambda1 = 1e-4
#lambda2 = 1e-4
maxIterPVCC = 150
epsilon = 1e-6
#SS = 100  # step size
class_num = 2
numL = split  # number of the labeled datapoint
numC = N  # TODO inc
H = np.zeros((v, N, N))
C = np.zeros((v, N, N))
s = np.zeros((v, N, N))  # view-specific similarity matrix S_i
M = np.zeros((N, N))  # global similarity matrix M
A = dict()
B = dict()
# Dimention of data point
data_dim = np.zeros((v), dtype=np.int32)
# Complete modalities in every modalities
eta = np.zeros((v))
eta += N  # Complete dataset for now TODO inc

X = dict()
X_test = dict()
X_val = dict()

for lambda1 in lambda1_box:
    for lambda2 in box:
        for SS in box:
            for i in range(v):
                X[i] = view_train[i + 1]
                X_test[i] = view_test[i + 1]
                X_val[i] = view_val[i + 1]
                data_dim[i] = view_train[i + 1].shape[1]

            for i in range(v):
                C[i] = np.eye(N) - np.ones((N, N)) / eta[i]  # TODO inc
                B[i] = X[i].T.dot(C[i].T)
                A[i] = B[i].dot(B[i].T) + eta[i] * lambda1 * np.eye(data_dim[i])

            for i in range(v):
                tmpX = np.zeros((N, data_dim[i]))
                for j in range(N):
                    y = np.square(X[i][j])
                    n = np.sqrt(y.sum())
                    if n != 0:

                        tmpX[j] = X[i][j] / n  # normalize per row
                    else:
                        tmpX[j] += 0
                s[i] = tmpX.dot(tmpX.T)

                M = M + s[i]
            M = M / v

            #Initialization
            f = np.zeros((N, class_num))
            for i in range(numL):

                f[i][int(label_train[i])] = 1

            #Unlabled part initialization
            for i in range(numL, N):
                K_nearest = np.argsort(M[i, :numL])
                #KNN initialization
                res = np.zeros((class_num))
                sum = 0.0
                for k in range(3):
                    t  = np.zeros((class_num))
                    t[int(label_train[K_nearest[k]])] =  1
                    res += M[i,K_nearest[k]] * t
                    sum += M[i,K_nearest[k]]
                if sum != 0:
                    #Weighted KNN
                    f[i] = res / sum
                else:
                    #Uniform
                    f[i] = np.ones((class_num)) / class_num


            sumH = np.zeros((N, N))
            aMb = dict()
            for i in range(v):
                aMb[i] = np.linalg.inv(A[i]).dot(B[i])
                H[i] = C[i].dot(C[i].T).dot(aMb[i].T).dot(
                    lambda1 / 2 * aMb[i] + 1 / (2 * eta[i]) * B[i].dot(B[i].T).dot(aMb[i]) - 1 / eta[i] * B[i]) + 1 / (2 * eta[i]) * C[i].T.dot(C[i])
                # TODO inc
                sumH += H[i]
            # print(f)
            object_value = dict()
            for i in range(maxIterPVCC):
                # print('Optimization step %d' % i)
                grad_1 = sumH.dot(f)
                M_approx = f.dot(f.T)
                grad_2 = np.zeros((N, class_num))
                for j in range(v):
                    dif = M_approx - s[j]
                    n = np.sqrt((dif ** 2).sum())
                    if n == 0:
                        proj = 0
                    else:
                        proj = dif / n  # TODO inc
                    grad_2 += proj.dot(f)/eta[j]

                grad_f = grad_1 + grad_2 * lambda2
                f -= SS * grad_f
                f = f.clip(0, 1)
                for idx in range(numL):
                    f[idx] *= 0
                    f[idx][int(label_train[idx])] = 1
                value = 0.0
                M_ = f.dot(f.T)
                for idx in range(v):
                    value += 1 / (2*eta[idx]) * np.sqrt(np.square(s[idx]-M_).sum())

                object_value[i] = np.trace(f.T.dot(sumH).dot(f)) + lambda2 * value
                pred = np.argmax(f, axis=1)
                # print(pred)
                acc = (pred == label_train).sum()
                acc = float(acc) / float(len(label_train))
                # print(f)
                if i > 0 and (np.abs(object_value[i] - object_value[i-1])/object_value[i]) < epsilon:
                    print("Training Accuracy: {:.2%}".format(acc))
                    object_value.clear()
                    break
                if i == maxIterPVCC - 1:
                    object_value.clear()
                    print("Training Accuracy: {:.2%}".format(acc))

            W = dict()
            b = np.zeros((v, class_num))
            for i in range(v):
                W[i] = aMb[i].dot(C[i]).dot(f)
                b[i] = ((f - X[i].dot(W[i])).T.dot(np.ones((N, 1))) / eta[i]).reshape(b[i].shape)

            val_predict = np.zeros((v,label_val.shape[0], class_num))


            for i in range(v):
                val_predict[i] = X_val[i].dot(W[i]) + b[i]
                val_max = np.argmax(val_predict[i], axis=1)
                acc = (val_max == label_val).sum()
                acc = float(acc) / float(label_val.shape[0])

                if acc > best_val_acc[i]:
                    best_val_acc[i] = acc

                    test_predict = X_test[i].dot(W[i]) + b[i]
                    test_predict = np.argmax(test_predict, axis=1)
                    acc = (test_predict == label_test).sum()
                    acc = float(acc) / float(label_test.shape[0])
                    best_test_acc[i] = acc

                    print("Modality:{}, Test : SS:{}, lambda1:{}, lambda2:{}, Accuracy: {:.2%}".format(i+1, SS,lambda1, lambda2, acc))

            if False and 0 > best_val_acc:
                best_val_acc = acc
                acc = 0.0
                test_predict = np.zeros((v,label_test.shape[0], class_num))
                for i in range(v):
                    test_predict[i] += X_test[i].dot(W[i]) + b[i]

                    pred = np.argmax(test_predict[i], axis=1)
                    acc += (pred == label_test).sum()
                acc = float(acc) /(v*float(label_test.shape[0]))
                best_test_acc = acc
                print("Test : SS:{}, lambda1:{}, lambda2:{}, Accuracy: {:.2%}".format(SS,lambda1, lambda2, acc))


print("Best:",best_test_acc)
