import argparse
import sys
import torch.nn.functional as F
import torch
sys.path.append('..')
sys.path.append('.')

from dataset.mat_reader import train_loader
from models.model import Net,Optimizer
class Config(object):

    adni_table_path = '..'



def train(epoch,device):


    for t in range(epoch):

        acc = 0.0
        train_loss = 0.0
        for idx, (data, label) in enumerate(train_loader):
            data = data.to(device)
            label = label.long().to(device)

            Optimizer.zero_grad()
            output = Net(data)
            loss = F.nll_loss(output, label)
            loss.backward()
            Optimizer.step()
            train_loss += loss.data

            pred = torch.max(output, 1)[1]
            acc += pred.eq(label.data).cpu().sum()

        acc = float(acc)/ float(len(train_loader.dataset))
        train_loss = float(train_loss)/ float(len(train_loader.dataset))
        print("Epoch:{}, Acc = {:.2%}, Loss = {:.4f}".format(t,acc,train_loss))



if __name__ == '__main__':

    parser = argparse.ArgumentParser(description='ADNI')
    parser.add_argument('--device', type=int)
    parser.add_argument('--epoch', type=int,default=10000,help="Number of epochs to train.")

    args = parser.parse_args()

    Net = Net.to(args.device)
    train(args.epoch,args.device)